#include "stdafx.h"

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"BScommon.h"
#include	"Backup.h"

typedef int (WINAPI *TFUNC)(HWND,char *,char *,unsigned int);
char tempDir[_MAX_PATH];
HINSTANCE   hInstDLL;	// DLL̃CX^Xnh
TFUNC       Unlha;		// DLLUnLha֐ւ̃|C^
static char *backupEntrys[ALL_BOOKMARKS - 1] = {
	MOZILLA_ARCHIVEENTRY_1,
	MOZILLA_ARCHIVEENTRY_2,
	OPERA_ARCHIVEENTRY_1,
	OPERA_ARCHIVEENTRY_2,
	FIREFOX_ARCHIVEENTRY_1,
	FIREFOX_ARCHIVEENTRY_2,
	SAFARI_ARCHIVEENTRY_1,
	SAFARI_ARCHIVEENTRY_2,
	CHROME_ARCHIVEENTRY_1,
	CHROME_ARCHIVEENTRY_2,
	XBEL_ARCHIVEENTRY_1,
	XBEL_ARCHIVEENTRY_2,
	OP15_ARCHIVEENTRY_1,
	OP15_ARCHIVEENTRY_2,
	OP19_ARCHIVEENTRY_1,
	OP19_ARCHIVEENTRY_2,
};

TFUNC getFunction(enum backup_type type)
{
	switch(type) {
		case LZH:
			return (TFUNC)GetProcAddress(hInstDLL,"Unlha");
		case ZIP:
			return (TFUNC)GetProcAddress(hInstDLL,"SevenZip");
		case SEVEN_ZIP:
			return (TFUNC)GetProcAddress(hInstDLL,"SevenZip");
	}
	return NULL;
}

enum backup_type getArchiveType(const char *filename)
{
	int len;

	len = strlen(filename);
	if (!stricmp(filename + (len - 4), ".LZH")) {
		return LZH;
	}

	if (!stricmp(filename + (len - 4), ".ZIP")) {
		return ZIP;
	}

	if (!stricmp(filename + (len - 3), ".7z")) {
		return SEVEN_ZIP;
	}
	return OTHER;
}

/**
 * A[JCoDLL[hB
 *
 * @param type A[JCu^Cv
 * @return NULL:A[JCoDLL̃CX^X NULL:[hs
 */
HINSTANCE loadArchiverDll(enum backup_type type)
{
	switch (type) {
		case LZH:
			return LoadLibrary(_T(UNLHA_DLL));
		case ZIP:
			return LoadLibrary(_T(SEVENZIP_DLL));
		case SEVEN_ZIP:
			return LoadLibrary(_T(SEVENZIP_DLL));
	}
	return NULL;
}

/**
 * Ō\ȍ~؂藣B<br>
 * pathȍ~𒼐ڏ̂ŒӁB<br>
 *
 * @param path Ώە
 * @return NULL:؂藣Ɏs NULL:؂藣ʒu
 */
char *cutLastPointer(char *path)
{
	char *find = NULL,*ptmp;
	
	if (path == NULL){
		return NULL;
	}

	if (*path == '\\'){	// ΃pX?
		path++;
		if (*path == '\\'){	// UNC\LB
			path++;
		}
	}
	while(*path){
		if (isleadbyte(*path)){
			path++;
		}else{
			if (*path == '\\'){
				ptmp = path;
				while(*path == '\\'){	// \₪Y΍
					path++;
				}
				path--;
				if (*(path+1))	// \0łȂ
					find = ptmp;
			}
		}
		path++;
	}
	if (find != NULL){
		*find = '\0';	// Ō̗vfԂ؂
		return find;
	}else{
		return NULL;
	}
}

/**
 * t@CWJR}h쐬B
 *
 * @param type A[JCu
 * @param arcFile A[JCut@C
 * @param buf R}hCobt@
 */
void extractFileCommand(
	enum backup_type &type,
	char const*arcFile,
	char const*memberName,
	char *buf)
{
	switch (type) {
		case LZH:
			strcpy(buf,"x -h2 \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\" ");
			strcat(buf,memberName);
			break;
		case ZIP:
			strcpy(buf,"e -aoa \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\" ");
			strcat(buf,memberName);
			break;
		case SEVEN_ZIP:
			strcpy(buf,"e -aoa \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\" ");
			strcat(buf,memberName);
			break;
	}
}

/**
 * l[ăA[JCuɊi[B
 *
 * @param arcFile ubN}[Ni[A[JCut@C
 * @param targetFile WJ̃pX
 * @param memberName ubN}[Ni[A[JCut@C̃t@C
 * @return 0: 1:s
 */
int renameExtract(
	enum backup_type type,
	const char *arcFile,
	const char *targetFile,
	const char *memberName
)
{
	int tempLength = GetTempPath(_MAX_PATH,tempDir);
	if (tempLength == 0){
		// e|fBNg擾łȂ
		return 1;
	}

	// UNLHA32.DLLpR}h쐬
	char buf[512];

	buf[511] = '\0';
	extractFileCommand(type, arcFile, memberName, buf);
	// WJsB
	int result = Unlha(NULL,buf,NULL,0);
	if (result){
		return 1;
	}

	// e|ɐVOŃRs[B
	strcat(tempDir,memberName);

	// e|烊l[Rs[sB
	result = CopyFile(tempDir,targetFile,FALSE);
	if (result == 0){
		// WJւ̃Rs[s
		return 1;
	}

	// e|͂Ȃ̂ō폜B
	DeleteFile(tempDir);

	return 0;
}

/**
 * CɓWJR}h쐬B
 *
 * @param type A[JCu
 * @param arcFile A[JCut@C
 * @param buf R}hCobt@
 * @param favoriteBase CɓfBNĝfBNg
 * @param favoriteDir CɓfBNg
 */
void extractFavoriteCommand(
	enum backup_type &type,
	char const*arcFile,
	char *buf,
	char *favoriteBase,
	char *favoriteDir)
{
	switch (type) {
		case LZH:
			strcpy(buf,"x -jf0 -d1 \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
		case ZIP:
			strcpy(buf,"x -aoa \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
		case SEVEN_ZIP:
			strcpy(buf,"x -aoa \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
	}
}
/**
 * ubN}[NECɓw肵A[JCut@CWJB
 *
 * @param arcFile i[̃A[JCut@C(tpX)
 * @param ieFavorite WJIÊCɓtH_(\Ȃ)
 * @param bookmarkFiles WJ̃ubN}[Nt@Cւ̔z
 * @return 0:obNAbvɐ 1:s
 */
int restoreBookmark(
	enum backup_type type,
	const char *arcFile,
	const char *ieFavorite,
	const char *bookmarkFiles[]
)
{

	char buf[512];
	int result;
	int i;

	hInstDLL = loadArchiverDll(type);
	if (hInstDLL == NULL){
#ifdef SELFTEST
		fprintf(stderr,"UNLHA32.DLL not found!!\n");
#else
		if (type == LZH) {
			MessageBox(NULL,"UNLHA32.DLL܂B","G[",MB_OK | MB_ICONWARNING);
		} else {
			MessageBox(NULL,"7-ZIP32.DLL܂B","G[",MB_OK | MB_ICONWARNING);
		}
#endif
		return 1;
	}
	Unlha = getFunction(type);

	if (ieFavorite != NULL){
		// CɓfBNgtpX番B
		char *p,favoriteBase[_MAX_PATH],favoriteDir[_MAX_PATH];
		strcpy(favoriteBase,ieFavorite);
		p = cutLastPointer(favoriteBase);	// Ō\TB
		if (p != NULL){
			strcpy(favoriteDir,p + 1);
		}else{
			strcpy(favoriteDir,"");
		}

		// UNLHA32.DLLpR}h쐬
		buf[511] = '\0';
		extractFavoriteCommand(type, arcFile, buf, favoriteBase, favoriteDir);
		// WJs
		result = Unlha(NULL,buf,NULL,0);
		if (result){
			FreeLibrary(hInstDLL);

			return 2;
		}
	}

	for (i = 0;i < (ALL_BOOKMARKS - 1);i++) {
		if (bookmarkFiles[i] != NULL) {
			result = renameExtract(type,arcFile,bookmarkFiles[i],backupEntrys[i]);
			if (result){
				FreeLibrary(hInstDLL);
				return 3 + i;
			}
		}
	}

	FreeLibrary(hInstDLL);

	return 0;
}


/**
 * t@CkR}h쐬B
 *
 * @param type A[JCu
 * @param arcFile A[JCut@C
 * @param buf R}hCobt@
 */
void packFileCommand(enum backup_type &type, char const*arcFile, char *buf)
{
	switch (type) {
		case LZH:
			strcpy(buf,"a -h2 \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\"");
			break;
		case ZIP:
			strcpy(buf,"a -tzip \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\"");
			break;
		case SEVEN_ZIP:
			strcpy(buf,"a -t7z \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,tempDir);
			strcat(buf,"\" -ms=off");
			break;
	}
}
/**
 * l[ăA[JCuɊi[B
 *
 * @param arcFile i[̃A[JCut@C
 * @param targetFile i[t@C
 * @param memberName i[̃A[JCut@C̃t@C
 * @return 0: 1:s
 */
int renamePack(
	enum backup_type type,
	const char *arcFile,
	const char *targetFile,
	const char *memberName
)
{
	int tempLength = GetTempPath(_MAX_PATH,tempDir);
	if (tempLength == 0){
		// e|fBNg擾łȂ
		return 1;
	}

	// e|ɐVOŃRs[B
	strcat(tempDir,memberName);

	int result = CopyFile(targetFile,tempDir,FALSE);
	if (result == 0){
		// e|ւ̃Rs[s
		return 1;
	}

	// UNLHA32.DLLpR}h쐬
	char buf[512];

	buf[511] = '\0';
	packFileCommand(type, arcFile, buf);
	// ksB
	result = Unlha(NULL,buf,NULL,0);

	// e|͂Ȃ̂ō폜B
	DeleteFile(tempDir);

	if (result){
		return 1;
	}else{
		return 0;
	}
}

/**
 * CɓkR}h쐬B
 *
 * @param type A[JCu
 * @param arcFile A[JCut@C
 * @param buf R}hCobt@
 * @param favoriteBase CɓfBNĝfBNg
 * @param favoriteDir CɓfBNg
 */
void packFavoritesCommand(
	enum backup_type &type,
	char const*arcFile,
	char *buf,
	char *favoriteBase,
	char *favoriteDir)
{
	switch (type) {
		case LZH:
			strcpy(buf,"a -jf0 -d1 -h2 \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
		case ZIP:
			strcpy(buf,"a -tzip \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
		case SEVEN_ZIP:
			strcpy(buf,"a -t7z -ms=off \"");
			strcat(buf,arcFile);
			strcat(buf,"\" \"");
			strcat(buf,favoriteBase);
			strcat(buf,"\\\" \"");
			strcat(buf,favoriteDir);
			strcat(buf,"\\*\"");
			break;
	}
}
/**
 * ubN}[NECɓw肵A[JCut@CɊi[B
 *
 * @param arcFile i[̃A[JCut@C(tpX)
 * @param ieFavorite i[IÊCɓtH_(\Ȃ)
 * @param bookmarkFiles ubN}[Nt@Cւ̔z
 * @return 0:obNAbvɐ 1:s
 */
int backupBookmark(
	enum backup_type type,
	const char *arcFile,
	const char *ieFavorite,
	const char *bookmarkFiles[]
)
{
	char buf[512];
	int result;
	int i;

	hInstDLL = loadArchiverDll(type);
	if (hInstDLL == NULL){
#ifdef SELFTEST
		fprintf(stderr,"UNLHA32.DLL not found!!\n");
#else
		if (type == LZH) {
			MessageBox(NULL,"UNLHA32.DLL܂B","G[",MB_OK | MB_ICONWARNING);
		} else {
			MessageBox(NULL,"7-ZIP32.DLL܂B","G[",MB_OK | MB_ICONWARNING);
		}
#endif
		return 1;
	}
	Unlha = getFunction(type);

	// ǉł͂Ȃ̂ŁAi[̃A[JCut@C폜ĂB
	DeleteFile(arcFile);

	// obNAbṽA[JCuǂݍ݂̊֌WIEȊOŏɎĂB
	for (i = 0;i < (ALL_BOOKMARKS - 1);i++) {
		if (bookmarkFiles[i] != NULL) {
			result = renamePack(type,arcFile,bookmarkFiles[i],backupEntrys[i]);
			if (result){
				FreeLibrary(hInstDLL);
				return 3 + i;
			}
		}
	}

	if (ieFavorite != NULL){
		// CɓfBNgtpX番B
		char *p,favoriteBase[_MAX_PATH],favoriteDir[_MAX_PATH];
		strcpy(favoriteBase,ieFavorite);
		p = cutLastPointer(favoriteBase);	// Ō\TB
		if (p != NULL){
			strcpy(favoriteDir,p + 1);
		}else{
			strcpy(favoriteDir,"");
		}

		// UNLHA32.DLLpR}h쐬
		buf[511] = '\0';
		packFavoritesCommand(type, arcFile, buf, favoriteBase, favoriteDir);

		// MessageBox(NULL,buf,"Test",MB_OK);
		// ks
		result = Unlha(NULL,buf,NULL,0);

		if (result){
			FreeLibrary(hInstDLL);
			return 2;
		}
	}

	FreeLibrary(hInstDLL);
	
	return 0;
}

#ifdef SELFTEST
int main(int argc,char *argv[])
{
	setlocale(LC_ALL,"japanese");
	_setmbcp(_MB_CP_LOCALE);

	int result;
/*
	backup(
		"test.lzh",
		"C:\\Documents and Settings\\Tatsu\\Application Data\\Mozilla\\Firefox\\Profiles\\34b5ta3h.default\\bookmarks.html",
		NULL,
		"C:\\Documents and Settings\\Tatsu\\Application Data\\Opera\\Opera\\profile\\Opera6.adr",
		"C:\\Documents and Settings\\Tatsu\\Favorites"
	);
*/
	result = restore(
		"test.lzh",
		"h:\\test\\bookmarks.html",
		NULL,
		"h:\\test\\Opera6.adr",
		"h:\\test\\Favorites"
	);

	if (result){
		fprintf(stderr,"XgAɎs܂B\n");
	}

}
#endif
