#ifndef FXBOOKMARK_H
#define FXBOOKMARK_H

#include	<stdio.h>
#include	<time.h>

class FxBookmark {
public:
	enum FolderType
	{
		normalFolder,		// ()tH_
		menuBar,	// j[o[tH_
		toolBar,	// c[o[tH_
		tags,		// ^O(Firefox 3)
		unFiled,	// Unfiled bookmark(Firefox 3)
		topFolder	// gbvx̃tH_(Firefox 3)
	};

private:
	char *m_id;				// fBNgID
	char *m_charset;		// R[h
	time_t m_check;			// ŏIXVmF
	char *m_Firefoxicon;	// ACR(Firefox)
	char *m_FeedUrl;		// RSStB[hURL
	char *m_feed_expiration;	// RSStB[h̊
	char *m_schedule;		// XVmFXPW[
	int m_group;			// tH_O[v̏ꍇ1
	int m_LinkbarFolder;	// tH_Personal toolbaȑꍇ1
	bool m_NewSearchFolder;	// tH_New Internet Search Foldeȑꍇtrue
	bool m_NewBookmarkFolder;	// tH_New Bookmark Foldeȑꍇtrue
	char *m_micsum_gen_uri;	// Micro summary generate URL(Firefox 2)
	char *m_micsum_expiration;	// Micro summary expiration(Firefox 2)
	char *m_generatedTitle;	// Generated title(Firefox 2)
	bool m_OrganizerFolder;	// I[KiCŨtH_
	bool m_OrganizerQuery;	// I[KiCŨubN}[N
	bool m_SmartBookmark;	// X}[gubN}[NH
	int m_excludeFromBackup;	// excludeFromBackup
	char *m_SyncParent;	// sync/parent
	char *m_MobileRoot;	// mobile/bookmarksRoot

//	static int m_sortMode;		// \[gۂ̏
	char *m_HRName;		// ؂̃x(Mozilla 1.4)
	bool m_webPanel;		// WEB_PANELݒ肳Ăꍇ1
	bool m_readOnly;		// ǂݍݐp̏ꍇtrue
	FolderType m_folderType;	// tH_̎
	char *m_ProperName;		// ubN}[NɌŗL̖O
	char *m_GUID;	// GUID

	// ǂݍłubN}[N̎
	static int m_mozVersion[2];	// (ǂݎΏۃuEŨo[W)
	// o͌`
	static int m_outputType[2];			// (R}hCŐݒ肳ꂽo͑ΏۃuEU)
	static int m_spaces;
	static bool m_UTF8[2];		// UTF-8ǂH
	static FILE *cs_fpo;		// ubN}[No͗pt@C|C^

	void _init();
	void spput(FILE *fp, int spaces);
	void putname(FILE *fp,wchar_t *name);
	void putname2(FILE *fp,char *name);
	void putDescription(FILE *fp,char *name);
	void putShortcut(FILE *fp,char *name);

protected:
	void _copy(const FxBookmark &src);
	void copy(const FxBookmark &src);

public:
	/* EʁEj */
	FxBookmark(void);
	FxBookmark(const FxBookmark &src);
	virtual ~FxBookmark();

	FxBookmark & operator = (const FxBookmark &src);
	void copyWithoutId(FxBookmark *src);
	int copyBookmarkIdentifier(FxBookmark *src);

	void reset(void);

	/* MozillaŗL */
	char *getID(void) const { return m_id; };
	char *setID(const char *item);
	char *getCharset(void) const { return m_charset; };
	char *setCharset(const char *item);
	time_t getCheck(void) const { return m_check; };
	time_t setCheck(const char *item);
	time_t setCheck(const time_t time) { m_check = time;return m_check; };
	char *getFirefoxIcon(void) const { return m_Firefoxicon; };
	char *setFirefoxIcon(const char *item);
	char *getFeedUrl(void) const { return m_FeedUrl; };
	char *setFeedUrl(const char *item);
	char *getFeed_expiration(void) const { return m_feed_expiration; };
	char *setFeed_expiration(const char *item);

	char *getSchedule(void) const { return m_schedule; };
	char *setSchedule(const char *item);
	int getGroup(void) const { return m_group; };
	int setGroup(const int status){ m_group = status;return m_group; };
	// ̃vpeBOpera 6̃ubN}[Nɂ̂ō킹Ă݂B
	// 0.9.8ɂ͂Ȃ悤ȋĈB
	int getLinkbarFolder(void) const { return m_LinkbarFolder; };
	int setLinkbarFolder(const int status) {m_LinkbarFolder = status;return m_LinkbarFolder;};
	bool getNewSearchFolder(void) const { return m_NewSearchFolder; };
	bool setNewSearchFolder(const bool status) {m_NewSearchFolder = status;return m_NewSearchFolder;};
	bool getNewBookmarkFolder(void) const { return m_NewBookmarkFolder; };
	bool setNewBookmarkFolder(const bool status) {m_NewBookmarkFolder = status;return m_NewBookmarkFolder;};
	bool getWebPanel(void) const { return m_webPanel; };
	bool setWebPanel(const bool status) {m_webPanel = status;return m_webPanel;};

	char *getHRName(void) const { return m_HRName; };
	char *setHRName(const char *item);

	char *getProperName(void) const { return m_ProperName; };
	char *setProperName(const char *item);

	// for Micro summary (Firefox 2)
	char *getMicsum_gen_uri(void) const { return m_micsum_gen_uri; };
	char *setMicsum_gen_uri(const char *item);
	char *getMicsum_expiration(void) const { return m_micsum_expiration; };
	char *setMicsum_expiration(const char *item);
	char *getGeneratedTitle(void) const { return m_generatedTitle; };
	char *setGeneratedTitle(const char *item);

	bool getReadOnly(void) const { return m_readOnly; };
	bool setReadOnly(const bool readOnly) {
		m_readOnly = readOnly;
		return m_readOnly;
	};

	FolderType getFolderType(void) const {
		return m_folderType;
	}
	void setFolderType(const FolderType type) {
		m_folderType = type;
	}

	// I[KiCŨtH_
	bool getOrganizerFolder(void) const { return m_OrganizerFolder; };
	bool setOrganizerFolder(const bool value) {
		m_OrganizerFolder = value;
		return m_OrganizerFolder;
	};

	// I[KiCŨNG
	bool getOrganizerQuery(void) const { return m_OrganizerQuery; };
	bool setOrganizerQuery(const bool value) {
		m_OrganizerQuery = value;
		return m_OrganizerQuery;
	};

	// X}[gubN}[N
	bool getSmartBookmark(void) const {return m_SmartBookmark;};
	bool setSmartBookmark(const bool value) {
		m_SmartBookmark = value;
		return m_SmartBookmark;
	};

	int getExcludeFromBackup() const
	{
		return m_excludeFromBackup;
	}
	int setExcludeFromBackup(const int value)
	{
		m_excludeFromBackup = value;
		return m_excludeFromBackup;
	}

	char *getSyncParent(void) const { return m_SyncParent; };
	char *setSyncParent(const char *item);

	char *getMobileRoot(void) const { return m_MobileRoot; };
	char *setMobileRoot(const char *item);

	// GUID̗L
	char *getGUID(void) const {
		return m_GUID;
	}
	char *setGUID(const char *item);

	/* o͌`̎擾Ǝw */
	static int getBrowserType(int no) { return m_outputType[no]; };
	static void setBrowserType(int no,int type){ m_outputType[no] = type;};
	/* ǂݍłubN}[N̎ނ̎w */
	static int getBrowserVersion(int no){ return m_mozVersion[no];};
	static void setBrowserVersion(int no,int type){ m_mozVersion[no] = type;};
	
	static bool isUTF8(int no){ return m_UTF8[no];};
	static bool setUTF8(int no,const bool mode){ m_UTF8[no] = mode;return m_UTF8[no];};

};

#endif	// __BOOKMARK_H
