//#if defined(_DEBUG) && defined(_MSC_VER)
//#define _CRTDBG_MAP_ALLOC
//#endif

#include	<stdlib.h>

//#if defined(_DEBUG) && defined(_MSC_VER)
//#include	<crtdbg.h>
//#endif

#include	<fstream>
#include	<iostream>
#include	<stdio.h>
#include	<string.h>
#include	<wchar.h>
#include	<direct.h>
#include	<locale.h>
#include	<windows.h>
#include	<winbase.h>
#include	<winnetwk.h>
#include	<shlobj.h>
#include	<winreg.h>
#include	<io.h>
#include	<time.h>

#include	"NTfunction.h"
#include	"BSCommon.h"
#include	"bslib.h"
#include	"encutil.h"
#include	"encutil2.h"
#include	"url.h"
#include	"BSStringHolder.h"

#include	"IeUtil.h"
#include	"IeWriter.h"
#include	"IeOrder.h"

#ifdef __BORLANDC__
#define	_stricmp stricmp
#endif

#define LANGUAGES 2

const char *IeWriter_message[LANGUAGES][5] = { {
		"Can't write Internet-Shortcut file.\nFilename:",
			"Can't create directory.\nDirectory name:",
		"Same name file found.\n",
		"Updated\n",
		"Not updated\n",
	},{
		"C^[lbgV[gJbgt@C݂̏Ɏs܂B\nt@C:",
			"fBNg̍쐬Ɏs܂B\nfBNg:",
		"łɃtH_Ɠ̃t@C݂Ă܂B\n",
		"XV\n",
		"XVȂ\n",
	}
};

/**
 * RXgN^
 */
IeWriter::IeWriter(void)
{
	mbPath = NULL;
	wcPath = NULL;
	regPath = NULL;
	try{
		mbPath = new char[BUFLEN];
		if (mbPath == NULL){
			return;
		}
		wcPath = new wchar_t[BUFLEN];
		if (wcPath == NULL){
			delete []mbPath;
			return;
		}
		regPath = new wchar_t[BUFLEN];
		if (regPath == NULL){
			delete []wcPath;
			delete []mbPath;
			return;
		}
	}catch(...){
		if (wcPath != NULL) {
			delete []wcPath;
		}
		if (mbPath != NULL){
			delete []mbPath;
		}
		return;
	}

	overwriteMode = true;

	try{
		urlBuf = new char[BUFLEN];
		if (urlBuf == NULL){
			delete []regPath;
			delete []mbPath;
			delete []wcPath;
			return;
		}
	}catch(...){
		delete []regPath;
		delete []mbPath;
		delete []wcPath;
		return;
	}

	wcPrefix = 0;	// \\?\`gȂ̂œɂ0
	placesPut = true;
	wcscpy(regPath, L"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");

	level = 0;

	unsigned char *order = (unsigned char *)calloc(BUFLEN, 1);
	orderInfo.push_back(order);
	orderInfoCurrent.push_back(0);
	orderItems.push_back(0);
	orderInfoSize.push_back(BUFLEN);
	if (order != NULL) {
		initOrderInfo(order);
	}
	manageOrder = true;
}

/**
 * fXgN^
 */
IeWriter::~IeWriter()
{
	if (regPath != NULL) {
		delete []regPath;
	}
	if (wcPath != NULL){
		delete []wcPath;
	}
	if (mbPath != NULL){
		delete []mbPath;
	}

	delete []urlBuf;

	// ԏ
	int size = orderInfo.size();
	for (int i = 0; i < size; i++) {
		if (orderInfo[i] != NULL) {
			free(orderInfo[i]);
		}
	}}

#define COPYCHAR(p,c)  if (p != NULL){*p = c;p++;}

/**
 * file:URL\LIEpɒB([Jt@Cp)
 *
 * @param escapedUrl ϊURL
 * @param srcUrl ϊURL
 * @return ϊ̕
 */
int IeWriter::toIEFileURL(char *escapedUrl,const char *srcUrl)
{
	int escaped;
	char c;

	escaped = 0;
	while (*srcUrl) {
		switch (*srcUrl) {
			case ' ':
			case '%':
			case '#':
			case '&':
			case '[':
			case ']':
				c = *srcUrl;
				sprintf(escapedUrl,"%%%02X",((int)c & 0xff));
				escapedUrl += 3;
				escaped += 3;
				break;
			default:
				*escapedUrl = *srcUrl;
				escapedUrl++;
				escaped++;
				break;
		}
		srcUrl++;
	}
	*escapedUrl = '\0';
	return 0;
}

/**
 * tH_쐬B(Windows 9xn)
 *
 * @param scFile tH_̃pX
 * @param bookmark ubN}[N̏
 * @return 0:쐬 1:쐬s
 */
int IeWriter::storeFolder(char *scFile,Bookmark *bookmark)
{
	DWORD dwAttr;
	int ret = 0;

	if (g_verbose){
		std::cout << "Folder name " << scFile << '\n' << std::flush;
	}

	dwAttr = GetFileAttributes(scFile);
	if (dwAttr == 0xffffffff){
		// fBNg݂Ȃꍇ͍쐬B
		if (_mkdir(scFile)){
			putMessageWithInfo(IeWriter_message[g_lang][1],scFile);
			ret = 1;
		}
	}else if (!(dwAttr & FILE_ATTRIBUTE_DIRECTORY)){
		// ̃t@C݂G[ƂB
		putMessage(IeWriter_message[g_lang][2]);
		ret = 1;
	}
	
	return ret;
}

/**
 * tH_쐬B(Windows NTn)
 *
 * @param scFile tH_̃pX
 * @param bookmark ubN}[N̏
 * @return 0:쐬 1:쐬s
 */
int IeWriter::storeFolderW(wchar_t *scFile,Bookmark *bookmark)
{
	DWORD dwAttr;
	int ret = 0;

//	if (g_verbose){
//		std::cout << "Folder name " << scFile << '\n' << std::flush;
//	}
	// wprintf(L"path:%s\n",scFile);

	dwAttr = gGetFileAttributesW(scFile);
	if (dwAttr == 0xffffffff){
		// printf("1\n");
		// fBNg݂Ȃꍇ͍쐬B
		if (!gCreateDirectoryW(scFile,NULL)){
			// printf("2\n");
			putMessageWithInfoW(IeWriter_message[g_lang][1],scFile);
			ret = 1;
		}
	}else if (!(dwAttr & FILE_ATTRIBUTE_DIRECTORY)){
		// printf("3\n");
		// ̃t@C݂G[ƂB
		putMessage(IeWriter_message[g_lang][2]);
		ret = 1;
	}
	
	return ret;
}

// INIt@C(IÊCɓ)p萔
static BSStringHolder cNULL(NULL,NULL);
static BSStringHolder cSECTION(MAKEDUALLITERAL("InternetShortcut"));
static BSStringHolder cURL(MAKEDUALLITERAL("URL"));
static BSStringHolder cICONFILE(MAKEDUALLITERAL("IconFile"));
static BSStringHolder cICONINDEX(MAKEDUALLITERAL("IconIndex"));
static BSStringHolder cWEBSLICESECTION(MAKEDUALLITERAL("MonitoredItem"));
static BSStringHolder cFEEDURL(MAKEDUALLITERAL("FeedUrl"));
static BSStringHolder cPREVIEWSIZE(MAKEDUALLITERAL("PreviewSize"));
static BSStringHolder cLIVEPREVIEW(MAKEDUALLITERAL("IsLivePreview"));

/**
 *	INIt@Cނ߂̃bp
 * @param section ރZNV
 * @param key ރL[
 * @param str ޕ(NTn:UTF-8/ASCII 9xn:}`oCg)
 * @param filename ރt@C
 */
BOOL IeWriter::WritePrivateProfileStringEx(BSStringHolder &section,BSStringHolder &key,char *str,BSStringHolder &filename)
{
	BOOL result;
	
	if (g_isWinNT){
		wchar_t *p;

		// p = mbtowcInternal(str);
		if (str != NULL){
			p = UTF8towcFileNameInternal(str);
		}else{
			p = NULL;	// l̏
		}

		//MessageBox(NULL,"Attach!","",MB_OK);
		result = gWritePrivateProfileStringW(section,key,p,filename);
		//int e = GetLastError();
		//MessageBox(NULL,"Attach!","",MB_OK);
	}else{
		result = WritePrivateProfileString(section,key,str,filename);
	}
	
	return result;
}

/**
 * Cɓ菑ݎ̃G[bZ[Wo͂B
 *
 * @param message G[bZ[W
 * @param scFile t@C
 */
void IeWriter::putWriteError(const char *message,BSStringHolder &scFile)
{
	if (g_isWinNT) {
		putMessageWithInfoW(message,scFile);
	} else {
		putMessageWithInfo(message,scFile);
	}
}

/**
 * ubN}[N(Cɓ)쐬B
 *
 * @param scFile t@C
 * @param bookmark ރubN}[N̏
 * @return 0: 1:s
 */
int IeWriter::storeBookmark(BSStringHolder &scFile,Bookmark *bookmark)
{
	char *p;		// R[hϊobt@̃|C^

	// IEɂ̓Zp[^ȂĂ̂͂Ȃ̂ŉɏݐƂB
	if (bookmark->getSeparator()) {
		return 0;
	}

	Bookmark *mozBookmark;

	mozBookmark = bookmark;

	m_chgTime = bookmark->getAdddate();
	if (m_chgTime < (INT_TIME_T)bookmark->getLastvisit()){
		m_chgTime = bookmark->getLastvisit();
	}

	// URL̏
	if (bookmark->getURL() != NULL) {
		// file:ȊÔƂ͂̂܂܏
		if (strncmp("file:", bookmark->getURL(),5) == 0){
			toIEFileURL(urlBuf, bookmark->getURL());
		} else {
			strcpy(urlBuf, bookmark->getURL());
		}
	}else{
		urlBuf[0] = '\0';
	}

	if (!g_isWinNT){
		// NTnȊO̓}`oCgɒB݂̌̏̓}`oCĝ܂܂ŏ܂B
		p = UTF8tombInternal(urlBuf);
	}else{
		p = urlBuf;
	}

	if (p == NULL){
		return 1;
	}

	if (!WritePrivateProfileStringEx(cSECTION,cURL,p,scFile)){
		putWriteError(IeWriter_message[g_lang][0],scFile);
		return 1;
	}

	// ACRMozillaIEŕ\LʂȂ̂ŃRo[gB
	if (mozBookmark->getIcon() != NULL){
		// Firefox 1.0̃ACR͕ʈ
		if (strncmp(mozBookmark->getIcon(),"data:",5)){
			if (!WritePrivateProfileStringEx(cSECTION,cICONFILE,mozBookmark->getIcon(),scFile)){
				putWriteError(IeWriter_message[g_lang][0],scFile);
			}
			if (!WritePrivateProfileStringEx(cSECTION,cICONINDEX,"1",scFile)){
				putWriteError(IeWriter_message[g_lang][0],scFile);
			}
		}
	}else{
		if (!WritePrivateProfileStringEx(cSECTION,cICONFILE,NULL,scFile)){
			putWriteError(IeWriter_message[g_lang][0],scFile);
		}
		if (!WritePrivateProfileStringEx(cSECTION,cICONINDEX,NULL,scFile)){
			putWriteError(IeWriter_message[g_lang][0],scFile);
		}
	}

	// WebSlice֘Ȁ
	if (mozBookmark->getIeBookmark()->getFeedUrl() != NULL) {
		if (mozBookmark->getURL() != NULL) {
			if (!strcmp(mozBookmark->getIeBookmark()->getFeedUrl(),mozBookmark->getURL())) {
				// URLWebXCXURLsB

				// FeedUrl
				p = mozBookmark->getIeBookmark()->getFeedUrl();
				if (!WritePrivateProfileStringEx(cWEBSLICESECTION,cFEEDURL,p,scFile)){
					putWriteError(IeWriter_message[g_lang][0],scFile);
					return 1;
				}

				// PreviewSize
				p = mozBookmark->getIeBookmark()->getPreviewSize();
				if (!WritePrivateProfileStringEx(cWEBSLICESECTION,cPREVIEWSIZE,p,scFile)){
					putWriteError(IeWriter_message[g_lang][0],scFile);
					return 1;
				}

				// IsLivePreview
				if (mozBookmark->getIeBookmark()->getLivePreview()) {
					if (!WritePrivateProfileStringEx(cWEBSLICESECTION,cLIVEPREVIEW,"true",scFile)){
						putWriteError(IeWriter_message[g_lang][0],scFile);
						return 1;
					}
				} else {
					if (!WritePrivateProfileStringEx(cWEBSLICESECTION,cLIVEPREVIEW,NULL,scFile)){
						putWriteError(IeWriter_message[g_lang][0],scFile);
						return 1;
					}
				}
			} else {
				// WebXCX֘AS폜
				if (!WritePrivateProfileStringEx(cWEBSLICESECTION,cNULL,p,scFile)){
					putWriteError(IeWriter_message[g_lang][0],scFile);
					return 1;
				}
			}
		}
	}

	// Cɓt@CtbVB
	WritePrivateProfileStringEx(cNULL,cNULL,NULL,scFile);

	if (m_chgTime != 0){
		if (g_isWinNT){
			setulFileTimeW(scFile,m_chgTime,bookmark->getAdddate());
		}else{
			setulFileTime(scFile,m_chgTime,bookmark->getAdddate());
		}
	}

	return 0;

}

/**
 * IÊCɓ̏ԏރL[쐬B
 *
 * @param key L[
 * @return 0: 1:s
 */
int IeWriter::writeOrderKey(wchar_t *key)
{
	LONG result;
	DWORD bufSize = 4;
	HKEY hKey;

	if (!manageOrder) {
		return 0;
	}

	// WXg̃L[B
	result = RegCreateKeyExW(HKEY_CURRENT_USER,key,
		0,NULL,REG_OPTION_NON_VOLATILE,
		KEY_WRITE,NULL,&hKey,NULL);
	if (result != ERROR_SUCCESS){
		return 1;
	}
	RegCloseKey(hKey);
	return 0;
}

/**
 * IÊCɓ̏ԏރL[쐬B
 *
 * @param key L[
 * @return 0: 1:s
 */
int IeWriter::writeOrder(wchar_t *key, unsigned char *buf, long size)
{
	LONG result;
	DWORD bufSize = 4;
	HKEY hKey;

	if (!manageOrder) {
		return 0;
	}

	// WXg̃L[B
	result = RegCreateKeyExW(HKEY_CURRENT_USER,key,
		0,NULL,REG_OPTION_NON_VOLATILE,
		KEY_WRITE,NULL,&hKey,NULL);
	if (result != ERROR_SUCCESS){
		return 1;
	}

	RegSetValueEx(hKey, "Order", 0, REG_BINARY, (const BYTE *)buf, size);
	RegCloseKey(hKey);

	return 0;
}

/**
 * IÊCɓ̏ԏB<br>
 * ԏ0ŏĂKvB
 *
 * @param info IÊCɓ̏ԏi[̈
 */
void IeWriter::initOrderInfo(unsigned char *info)
{
	// wb_̂A0ȊOŎOɒl܂Ăӏݒ肷B
	info[0] = 0x08;
	info[4] = 0x02;
	info[12] = 0x01;

	orderInfoCurrent[level] = 20;
	orderItems[level] = 0;
}

/**
 * ԏݒ肷B
 *
 * @param path ԏݒ肷tH_Et@C̃tpX
 */
void IeWriter::setOrderInfo(wchar_t *path)
{
	unsigned char *item;
	unsigned char *p;
	int order = orderItems[level];
	long size;
	long total;

	if (path == NULL) {
		return;
	}
	if (orderInfo[level] == NULL) {
		return;
	}

	// ITEMIDLIST擾B
	item = (unsigned char *)createIDList(path);
	if (item == NULL) {
		return;
	}
	size = item[1];
	size = size << 8;
	size = size + item[0];
	total = size;

	if (size & 1) {
		total++;
	}
	total += 14;	// TCYi[̈ƏԂƃtO2oCg
	if ((orderInfoCurrent[level] + total) > orderInfoSize[level]) {
		unsigned char *newBuf = (unsigned char *)realloc(orderInfo[level], orderInfoSize[level] * 2);
		if (newBuf == NULL) {
			free(item);
			return;
		}
		orderInfoSize[level] = orderInfoSize[level] * 2;
	}

	// TCY
	long offset = orderInfoCurrent[level];
	long tmp = total;
	for (int i = 0; i < 4; i++) {
		p = orderInfo[level] + offset + i;
		*p = (unsigned char)(tmp & 0xff);
		tmp = tmp >> 8;
	}

	// 
	offset += 4;
	tmp = order;
	for (int i = 0; i < 4; i++) {
		p = orderInfo[level] + offset + i;
		*p = (unsigned char)(tmp & 0xff);
		tmp = tmp >> 8;
	}

	// ITEMIDLIST
	offset += 4;
	memcpy(orderInfo[level] + offset, item, size);
	offset += size;

	// Padding
	if (size & 1) {
		p = orderInfo[level] + offset;
		*p = 0x00;
		offset++;
	}

	// ???
	for (int i = 0; i < 2; i++) {
		p = orderInfo[level] + offset + i;
		*p = 0x00;
	}

	// flag
	offset += 2;
	tmp = 0;
	for (int i = 0; i < 4; i++) {
		p = orderInfo[level] + offset + i;
		*p = (unsigned char)(tmp & 0xff);
		tmp = tmp >> 8;
	}

	orderInfoCurrent[level] = orderInfoCurrent[level] + total;
	orderItems[level] = order + 1;
}

/**
 * IÊCɓ̃tH_
 *
 * @param item ރubN}[ÑtH_
 */
void IeWriter::putFolder(Bookmark *item)
{
	int ret;	// ϊ
	char *sfn;
	wchar_t *wfn;

	if (item->getIeBookmark()->getFsDirName() != NULL) {
		// IEDscktop.iniŃt@Cw肳Ăꍇ
		wfn = item->getIeBookmark()->getFsDirName();
		sfn = wctombInternal(wfn);
		if (sfn == NULL) {
			// ܂AsȂƎvÔ߁B
			sfn = item->getIeName();
		}
	} else {
		// IEDscktop.iniŃt@Cw肳ĂȂꍇ
		sfn = item->getIeName();
		wfn = item->getIeNameW();
	}

	// tH_̃pX̍쐬(}`oCg)
	mbstrncatFit((unsigned char *)mbPath,(unsigned char *)"\\",246 /* _MAX_DIR */);
	/* \.url\0̕cČB */
	mbstrncatFit((unsigned char *)mbPath,(unsigned char *)sfn,247 /* _MAX_DIR */);

	wcsncatFit(wcPath,L"\\",246 + wcPrefix /* _MAX_DIR */);
	/* \.url\0̕cČB */
	wcsncatFit(wcPath,wfn,247 + wcPrefix /* _MAX_DIR */);

	// ԊǗ̃WXg
	wcscat(regPath, L"\\");
	wcscat(regPath, wfn);

	// ԏݒ肷B
	if (manageOrder) {
		setOrderInfo(wcPath);
	}

	// ԊǗp
	level++;

	// Cɓ̏ԏݒ
	int result = writeOrderKey(regPath);

	unsigned char *order = (unsigned char *)calloc(BUFLEN, 1);
	if (orderInfo.size() == level) {
		orderInfo.push_back(order);
		orderInfoCurrent.push_back(0);
		orderItems.push_back(0);
		orderInfoSize.push_back(BUFLEN);
	} else {
		orderInfo[level] = order;
		orderInfoCurrent[level] = 0;
		orderItems[level] = 0;
		orderInfoSize[level] = BUFLEN;
	}
	if (order != NULL) {
		initOrderInfo(order);
	}

	// tH_̃pX̍쐬(Unicode)
	if (g_isWinNT){
		ret = storeFolderW(wcPath,item);
	}else{
		ret = storeFolder(mbPath,item);
	}

}

/**
 * tH_̏I
 *
 */
void IeWriter::putFolderEnd(Bookmark *item,bool isLast)
{
	// ԏoB
	if (manageOrder) {
		if (orderInfo[level] != NULL) {
			long offset = 8;
			long tmp = orderInfoCurrent[level] - 8;
			unsigned char *p;
			for (int i = 0; i < 4; i++) {
				p = orderInfo[level] + offset + i;
				*p = (unsigned char)(tmp & 0xff);
				tmp = tmp >> 8;
			}

			offset = 16;
			tmp = orderItems[level];
			for (int i = 0; i < 4; i++) {
				p = orderInfo[level] + offset + i;
				*p = (unsigned char)(tmp & 0xff);
				tmp = tmp >> 8;
			}
			writeOrder(regPath, orderInfo[level], orderInfoCurrent[level]);
		}
	}

	// pX߂
	cutLast(mbPath);
	cutLastW(wcPath);
	cutLastW(regPath);

	if (orderInfo[level] != NULL) {
		free(orderInfo[level]);
		orderInfo[level] = NULL;
	}
	level--;
}

/**
 * IÊCɓ
 *
 * @param item ރubN}[N
 */
void IeWriter::putBookmark(Bookmark *item,bool isLast)
{
	int ret;
	char *descBuf = NULL;	// Netscape 4/6
	bool mbCatFlag = false;
	bool wcCatFlag = false;

	if (!placesPut) {
		// Firefox 3̃X}[gubN}[NtH_炱𖳎B
		if (item->isPlaceURI()) {
			return;
		}
	}

	if (item->getSeparator()) {
		// Zp[^IEɑ݂Ȃ̂ŔB
		return;
	}

	/*
	// IEŎgȂt@CEtH_ϊB
	if (item->getIeName() != NULL) {
		changeIeInvalidName(item);
	}
	if (item->getIeNameW() != NULL) {
		changeIeInvalidNameW(item);
	}
	*/

	int lenBefore = strlen(mbPath);
	// tH_؂
	mbstrncatFit((unsigned char *)mbPath,(unsigned char *)"\\",MAX_PATH - 6);
	// ubN}[N
	mbstrncatFit((unsigned char *)mbPath,(unsigned char *)item->getIeName(),MAX_PATH - 6);
	// gq
	mbstrncatFit((unsigned char *)mbPath,(unsigned char *)".url",MAX_PATH - 1);
	int lenAfter = strlen(mbPath);
	// pX̊Kw̌vZ
	if (lenBefore < lenAfter){
		mbCatFlag = true;
	}

	lenBefore = wcslen(wcPath);
	// tH_؂
	wcsncatFit(wcPath,L"\\",260 + wcPrefix - 4);
	// ubN}[N
	wcsncatFit(wcPath,item->getIeNameW(),260 + wcPrefix - 4);
	// gq
	wcsncatFit(wcPath,L".url",260 + wcPrefix);
	lenAfter = wcslen(wcPath);
	// pX̊Kw̌vZ
	if (lenBefore < lenAfter){
		wcCatFlag = true;
	}

	// ԏݒ肷B
	if (manageOrder) {
		setOrderInfo(wcPath);
	}

	BSStringHolder filename(wcPath,mbPath);
	ret = storeBookmark(filename,item);

	if (mbCatFlag){	// }`oCg̃ubN}[NpXɕǉꍇ
		cutLast(mbPath);
	}
	if (wcCatFlag){	// Ch̃ubN}[NpXɕǉꍇ
		cutLastW(wcPath);
	}
}

/**
 * IÊCɓtH_ݒ肷(}`oCg)
 *
 * @param folder tH_̕
 */
void IeWriter::setFavoritesFolder(const char *folder)
{
	strcpy(mbPath,folder);
}

/**
 * IÊCɓtH_ݒ肷(Unicode)
 *
 * @param folder tH_̕
 */
void IeWriter::setFavoritesFolderW(const wchar_t *folder)
{
	wcscpy(wcPath,folder);
}

/**
 * ubN}[Ñt@CGhށB<br>
 * IÊCɓł͍ŏ̃tH_̏Ԃݒ肷̂ɎgpB
 */
void IeWriter::putFooter(void)
{
	level = 0;

	if (!manageOrder) {
		return;
	}

	if (orderInfo[level] != NULL) {
		long offset = 8;
		long tmp = orderInfoCurrent[level] - 8;
		unsigned char *p;
		for (int i = 0; i < 4; i++) {
			p = orderInfo[level] + offset + i;
			*p = (unsigned char)(tmp & 0xff);
			tmp = tmp >> 8;
		}

		offset = 16;
		tmp = orderItems[level];
		for (int i = 0; i < 4; i++) {
			p = orderInfo[level] + offset + i;
			*p = (unsigned char)(tmp & 0xff);
			tmp = tmp >> 8;
		}
		writeOrder(regPath, orderInfo[level], orderInfoCurrent[level]);
	}
}